#include "inputmedium.hh"
#include "calibrationrequest.hh"



/* *** Constructors *** */


InputMedium::InputMedium():
  current_line_nb(0)
{
  current_request = new Request() ;
}


InputMedium::~InputMedium()
{
  delete current_request ;
}



/* *** Operations *** */


void InputMedium::
current_request_to_calibration_request(uint_fast8_t request_type)
{
  if (dynamic_cast<CalibrationRequest*>(current_request) != NULL)
    {
      current_request->set_type(request_type) ;
      return ;
    }

  Request *tmp = current_request ;
  current_request = NULL ;
  current_request = new CalibrationRequest(*tmp) ;
  current_request->set_type(request_type) ;
  delete tmp ;
}


void InputMedium::clear_current_request()
{
  if (dynamic_cast<CalibrationRequest*>(current_request) == NULL)
    current_request->clear() ;
  else
    {
      delete current_request ;
      current_request = NULL ;
      current_request = new Request() ;
    }
}
