#ifndef _OWLPS_POSITIONING_POSITIONINGALGORITHM_HH_
#define _OWLPS_POSITIONING_POSITIONINGALGORITHM_HH_

#include "request.hh"
#include "result.hh"

/// Super-class of all positioning algorithms
class PositioningAlgorithm
{
protected:
  /// Name of the algorithm
  const std::string name ;

public:
  PositioningAlgorithm(const std::string _name = "UnknownAlgorithm"):
    name(_name) {}
  virtual ~PositioningAlgorithm(void) {}

  virtual Result compute(const Request &request) = 0 ;
} ;

#endif // _OWLPS_POSITIONING_POSITIONINGALGORITHM_HH_
